"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VerificationService = void 0;
var core_1 = require("@ethereum-sourcify/core");
var Injector_1 = require("./Injector");
var VerificationService = /** @class */ (function () {
    function VerificationService(fileService, logger) {
        var _this = this;
        this.findByAddress = function (address, chain, repository) { return __awaiter(_this, void 0, void 0, function () {
            var matches, err_1, msg;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        matches = [];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.fileService.findByAddress(address, chain, repository)];
                    case 2:
                        matches = _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        err_1 = _a.sent();
                        msg = "Could not find file in repository";
                        this.logger.info({
                            loc: '[POST:VERIFICATION_BY_ADDRESS_FAILED]',
                            address: address
                        }, msg);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, matches];
                }
            });
        }); };
        this.inject = function (inputData, localChainUrl) { return __awaiter(_this, void 0, void 0, function () {
            var injector;
            return __generator(this, function (_a) {
                injector = new Injector_1.Injector({
                    localChainUrl: localChainUrl,
                    log: this.logger,
                    infuraPID: process.env.INFURA_ID,
                    repositoryPath: this.fileService.repositoryPath,
                    fileService: this.fileService
                });
                return [2 /*return*/, injector.inject(inputData)];
            });
        }); };
        this.logger = logger || core_1.Logger("VerificationService");
        this.fileService = fileService || new core_1.FileService("./repository");
    }
    return VerificationService;
}());
exports.VerificationService = VerificationService;
//# sourceMappingURL=VerificationService.js.map